//=====================================================================//
//                                                                     //
//  ե̾ : ImageFileIO.c                                         //
//         : ppm (Portable PixMap), pgm (Portable GrayMap)ե //
//               ϥǡɤ߹ߤӽϥǡ񤭽Ф  //
//               Ԥ                                                //
//       : 2003. 3. 21  ʿ (Computer Vision & Games Lab.)  //
//               2004. 2. 15 ¼  (Computer Graphics Lab.)        //
//               2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)          //
//                                                                     //
//=====================================================================//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#include "ImageFileIO.h"

void SkipCommentLine(FILE * fp);

//---------------------------------------------------------------------//
// void GetAxisFromIndex(int iWidth, int iIndex, int * iX, int * iY)   //
//        : Υǥå飲ɸ               //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)           //
//                                                                     //
// []                                                              //
// iWidth       : ϡ˲ʲǿ                           //
// iX           : ϡ˲κɸʲǿ                       //
// iY           : ϡ˽κɸʲǿ                       //
// iIndex       : ʽϡ˥ǥå                                 //
//---------------------------------------------------------------------//
void GetAxisFromIndex(int iWidth, int iIndex, int * iX, int * iY) {
    *iX = iIndex%iWidth;
    *iY = iIndex/iWidth;
}

//---------------------------------------------------------------------//
// void GetIndexFromAxis(int iWidth, int iX, int iY, int * iIndex)     //
//        : ɸ飱Υǥå               //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)           //
//                                                                     //
// []                                                              //
// iWidth       : ϡ˲ʲǿ                           //
// iIndex       : ϡ˥ǥå                                 //
// iX           : ʽϡ˲κɸʲǿ                       //
// iY           : ʽϡ˽κɸʲǿ                       //
//---------------------------------------------------------------------//
void GetIndexFromAxis(int iWidth, int iX, int iY, int * iIndex) {
    *iIndex = iWidth*iY + iX;
}



//--------------------------------------------------------------------//
// int * ReadPgm(int * iWidth, int * iHeight, int * iMaxValue)    //
//        : PGMեɤ߹                                 //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)        //
//              2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)          //
//                                                                    //
// []                                                           //
//              : ([ǿ])PGMΥǡ                   //
//                ǿ=iWidth * iHeight                             //
// []                                                             //
// iWidth       : ʲǿ                                  //
// iHeight      : ι⤵ʲǿ                                //
// iMaxValue    : βͤκ                                //
//--------------------------------------------------------------------//
int * ReadPgm(int  *iWidth, int *iHeight, int *iMaxValue) {

    FILE *fp;                    // եݥ
    char chFileName[80];         // ե͡
    enum PGM {P2, P5};           // ƥȷ or Хʥ
    int iPGMType;                // P2 or P5
    const int MAXCHARS = 100;    // Ԥκʸ
    char chLine[MAXCHARS];       // եǧѿ
    int * piInputData;           // ϥǡǼѿ
    unsigned char * pucData;     // ϥǡǼѿ
    int iNumPixels;              // ǿ
    int iIndex;                  // ǥå
    int w, h;                    // 롼ץ
    
    // ե̾
    printf("Input INPUT PGM file name[*.pgm]? > ");
    scanf("%s", chFileName);

    // Ϥ줿եΥץ
    // ץ˼Ԥξϡ顼ʸϤ֤ͤȤƣ֤l[j++]++;l[j++]++;l[j++]++;l[j++]++;l[j++]++;l[j++]++;l[j++]++;
   // if((fp = fopen("./face/%s.pgm", "r"),chFileName) == NULL){
  if((fp = fopen(chFileName, "r")) == NULL){
        fprintf(stderr, "Cannot open file [%s].\n", chFileName);
        exit(1);
    }

    // إåΰɤ߹
    fgets(chLine, MAXCHARS, fp);

    // PPM(P3)ǤϤʤ硢顼ʸϤ֤ͤȤƣ֤
    if (strncmp(chLine, "P2", 2) == 0){
	iPGMType = P2;
    } else if (strncmp(chLine, "P5", 2) == 0){
	iPGMType = P5;
	fclose(fp);
	fp = fopen(chFileName, "rb");
	fgets(chLine, MAXCHARS, fp);
    } else {
	fprintf(stderr, "[%s] is not PGM file.\n", chFileName);
        exit(1);
    }

    // ȹԤɤФ
    SkipCommentLine(fp);

    // ǡ顢⤵ɤ߹
    fgets(chLine, MAXCHARS, fp);
    sscanf(chLine, "%d %d", iWidth, iHeight);

    // ȹԤɤФ
    SkipCommentLine(fp);

    // ǡ顢٤ɤ߹
    fgets(chLine, MAXCHARS, fp);
    sscanf(chLine, "%d", iMaxValue);
    iNumPixels = (*iWidth)*(*iHeight);

    // ϲǡΥΰγ
    // piInputData[iWidth*iHeight]
    piInputData = (int *)(malloc(iNumPixels*sizeof(int)));

    // ȹԤɤФ
    SkipCommentLine(fp);

    // ͤɤ߹
    if(iPGMType == P5) {
	pucData = (unsigned char *)malloc(iNumPixels*sizeof(unsigned char));
	fread(pucData, sizeof(unsigned char), iNumPixels, fp);
    }
    for(h = 0; h < *iHeight; h++) {
	for(w = 0; w < *iWidth; w++) {
	    if(iPGMType == P2) {
		if(feof(fp)) {
		    fprintf(stderr, "Error: [%s] is not a correct PGM file.\n",
			    chFileName);
		    exit(-1);
		}

		// ǤΥǡɤ߹ߡǼ
		GetIndexFromAxis(*iWidth, w, h, &iIndex);
		fscanf(fp, "%d", &piInputData[iIndex]);
	    } else { // P5
		GetIndexFromAxis(*iWidth, w, h, &iIndex);
		piInputData[iIndex] = pucData[iIndex];
	    }
        }
    }

    // եΥ
    fclose(fp);  

    return piInputData;
}

//---------------------------------------------------------------------//
// void FreePgm(int * piOutputData)                                    //
//        : PGMβǡ¸Ƥΰγ      //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)           //
//                                                                     //
// []                                                              //
// piOutputData : ([ǿ][RGB])PGMΥǡ               //
//---------------------------------------------------------------------//
void FreePgm(int * piOutputData) {
    free(piOutputData);
}

//---------------------------------------------------------------------//
// void WritePgm(int * piOutputData, int iWidth,                       //
//               int iHeight, int iMaxValue)                           //
//        : PGMեؽ񤭽Ф                                  //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)           //
//                                                                     //
// []                                                              //
// piInputData  : ([ǿ])PGMΥǡ                    //
//                ǿ=iWidth * iHeight                              //
// iWidth       : ʲǿ                                   //
// iHeight      : ι⤵ʲǿ                                 //
// iMaxValue    : βͤκ                                 //
//---------------------------------------------------------------------//
void WritePgm(int * piOutputData, int iWidth, int iHeight, int iMaxValue) {

    FILE *fp;              // եݥ
    char chFileName[80];   // ե͡
    int i;                 // 롼ץ

    // ϥե̾
    printf("Input OUTPUT PGM file name[*.pgm]? > ");
    scanf("%s", chFileName);

    // ϥեΥץ
    // ץ˼Ԥξϡ顼ʸϤ֤ͤȤƣ֤.
    if((fp = fopen(chFileName, "w")) == NULL){
        fprintf(stderr, "Cannot open file [%s].\n", chFileName);
        exit(1);
    }

    // إåΰ񤭹()
    fprintf(fp, "P2\n");
    fprintf(fp, "%d %d\n", iWidth, iHeight);
    fprintf(fp, "%d\n", iMaxValue);  // 

    // Ʋǥǡ񤭹
    for(i = 0; i < iWidth*iHeight; i++){
    
        // ͤեν񤭹
        fprintf(fp, "%5d", piOutputData[i]);
                
        // 10ͤȤ˲
        if((i + 1)%15 == 0){
           fprintf(fp, "\n");
        }
    }

    // եΥ
    fclose(fp);
}

//---------------------------------------------------------------------//
// void SkipCommentLine(FILE * fp)                                     //
//        : ȹԤɤФ                                 //
//      : 2004. 2. 15 ¼  (Computer Graphics Lab.)         //
//              2011. 4. 11 ƣ ãϺ (Computer Vision Lab.)           //
//                                                                     //
// []                                                              //
// fp     : ե륹ȥ꡼ݥ                                 //
//---------------------------------------------------------------------//
void SkipCommentLine(FILE * fp) {
    
    const int MAXCHARS = 100;
    char chLine[MAXCHARS]; 
    fpos_t current;

    while(!feof(fp)) {
	// ߤΥȥ꡼֤¸
	fgetpos(fp, &current);
	
	// Լ
	fgets(chLine, MAXCHARS, fp);

	// ȹԤǤʤСȥ꡼֤ᤷƥ꥿
	if(chLine[0] != '#') {
	    fsetpos(fp, &current);
	    return;
	}
    }    
}

